package main

import (
	"fmt"
	"github.com/jinzhu/gorm"
	_ "github.com/jinzhu/gorm/dialects/mysql"
	"main.go/paginator"
	"main.go/paginator/adapter"
	"time"
)

type NewPost struct {
	ID          uint `gorm:"primary_key"`
	Title       string
	Body        string
	PublishedAt time.Time
}

func main() {
	db,err := gorm.Open("mysql","root:123456@(localhost)/go_mysql?charset=utf8mb4&parseTime=True&loc=Local")
	if err != nil {
		fmt.Println("gorm open msyql failed,err",err)
	}

	db.AutoMigrate(&NewPost{})

	var posts []NewPost

	q := db.Model(NewPost{}).Where("id > ?", 23)
	p := paginator.New(adapter.NewGORMAdapter(q), 10)
	p.SetPage(1)
	fmt.Println(p.HasNext())
	fmt.Println(p.HasPrev())
	fmt.Println(p.PageNums())
	a,_ := p.NextPage()
	b,_ := p.PrevPage()
	fmt.Println(a,b)
	p.SetPage(1)
	fmt.Println(p.HasPages())
	fmt.Println(p.Nums()) // 数据的总数
	fmt.Println(p.Page())



	if err = p.Results(&posts); err != nil {
		panic(err)
	}

	for _, post := range posts {
		fmt.Println(post.Title)
	}



}